//  Mouse PS/2 for Thomson  TO8
//  PS/2 Protocol  =  Arduino Community
//  Mouse TO8 Protocol =  6502MAN

#include <ps2.h>



// PS2 mouse(clock pin, data pin)  //
PS2 mouse(11, 10); // connecteur PS/2 sur Arduino


#define Bouton1Pin 13 // Bouton1
#define Bouton2Pin 12 // Bouton2
#define XaPin 6 // Xa
#define YaPin 7 // Ya
#define YbPin 8 // Yb
#define XbPin 9 // Xb

#define TurboLed  2  //  led d'activation du mode turbo


char MouseID=0,MSmode=0;
int TURBOon=0;





/*
 * initialize the mouse. Reset it, and place it into remote
 * mode, so we can get the encoder data on demand.
 */
void mouse_init()
{
    pinMode(TurboLed, OUTPUT);
    digitalWrite(TurboLed, LOW);
	
  int STATUSPS2=0;
  
    Serial.print("\n\n\n6502MAN PS/2 MOUSE TO TO8  \n\n");
    Serial.print("mouse INIT\n\n");
    Serial.print("CMD reset...");
  mouse.write(0xff);  // reset
    Serial.print(" OK\n");
  STATUSPS2=mouse.read();        // ack
    Serial.println(STATUSPS2, BIN);
  mouse.read();  // blank
  mouse.read();  // blank
  mouse.write(0xf0);  // remote mode
  STATUSPS2=mouse.read();        // ack
    Serial.println(STATUSPS2, BIN);
  
  
 //------------------------------
 //  ajout 6502MAN
  mouse.write(0xeb);   // demande datas
  mouse.read();        // ignore ack
  mouse.read() ; // ignore  boutons
  mouse.read();        // ignore X
  mouse.read();        // ignore Y
   
  Serial.print("\n\nCMD set sample rate1\n");
  mouse.write(0xf3);   // Set sample rate
    STATUSPS2=mouse.read();        // ack
    Serial.print(STATUSPS2, BIN);
	Serial.print(".....\n");
  mouse.write(200);    // Max sample rate
    STATUSPS2=mouse.read();        // ack
    Serial.print(STATUSPS2, BIN);
  Serial.print("\n..1 OK\n");

 //-------------------------------
 //  interroge le mode 3 si compatible
  mouse.write(0xf3);   // Set sample rate
  mouse.read();        // ack
  mouse.write(100);
  mouse.read();        // ack  
    Serial.print("..2 OK\n");
  mouse.write(0xf3);   // Set sample rate
  mouse.read();        // ack
  mouse.write(80);
  mouse.read();        // ack  
    Serial.print("..3 OK\n");
//-------------------------------

  Serial.print("CMD get device ID\n");
  mouse.write(0xf2);   // Get device ID
  mouse.read();        // ack
  MouseID = mouse.read();   // Mouse ID
  Serial.print("Mouse ID: ");
  Serial.print(MouseID,DEC);
  Serial.print("\nOK\n");
  
  Serial.print("CMD set sample rate OK\n");
  mouse.write(0xf3);   // Set sample rate
  mouse.read();        // ack
  mouse.write(200);    // Max sample rate
  mouse.read();        // ack  
  Serial.print(" OK\n");
  
  Serial.print("CMD set resolution\n");
  mouse.write(0xe8);   // Set Resolution
  mouse.read();        // ack
  mouse.write(3);      // 8 counts/mm
  mouse.read();        // ack  
  Serial.print(" OK\n");

 //------------------------------
  delayMicroseconds(100);
  
  
 /*------------------------------ 
 *  GESTION MODE TURBO au démarrage
 *
 *	Pour activer le Mode Turbo :
 *  appuyer sur le bouton reset de l'Arduino
 *  et apres avoir relacher le bouton reset maintenez appuye
 *  le bouton droit de la souris  
 */
  mouse.write(0xeb);   // commande "demande datas"
  mouse.read();        // ignore ack
  MSmode = mouse.read() & 2 ; // lit l'etat du bouton droit
     Serial.print("MSmode: ");
     Serial.print(MSmode, BIN);
     Serial.print("=");
     Serial.print(MSmode, DEC);Serial.print(" / ");
     Serial.print(mouse.read(),BIN);Serial.print("  |  "); 
     Serial.println(mouse.read(),BIN);
     if (MouseID) { mouse.read(); }
	 
     if (MSmode) {TURBOon=400; digitalWrite(TurboLed, HIGH); Serial.print("TURBO MODE ON"); } else {TURBOon=0;}		//	active le mode turbo ou non
 //------------------------------
  
  
  
    Serial.print("INIT mouse PS/2 FINISH  OK\n\n");
  
  // ---   INIT PIN TO8
  Serial.print("INIT PIN TO8\n");
  pinMode(Bouton1Pin,OUTPUT);
  pinMode(Bouton2Pin,OUTPUT);
  pinMode(XaPin,OUTPUT);
  pinMode(XbPin,OUTPUT);
  pinMode(YaPin,OUTPUT);
  pinMode(YbPin,OUTPUT);
  
	digitalWrite(Bouton1Pin,HIGH);
	digitalWrite(Bouton2Pin,HIGH);
	digitalWrite(XaPin,HIGH);
	digitalWrite(XbPin,HIGH);
	digitalWrite(YaPin,HIGH);
	digitalWrite(YbPin,HIGH);

  Serial.print("INIT PIN TO8 FINISH OK\n\n");
  
}





void EnterTurboMode()
{
	digitalWrite(TurboLed, HIGH);
      Serial.println("\nTURBO MODE\n");
      for (int i=0; i <= (10); i++)
      {
	digitalWrite(XaPin,LOW);
		delayMicroseconds(150);
	digitalWrite(XbPin,LOW);
		delayMicroseconds(150);
	digitalWrite(XaPin,HIGH);
		delayMicroseconds(150);
	digitalWrite(XbPin,HIGH);
		delayMicroseconds(150);
        i++;
        }
        delay(50);
       for (int i=0; i <= (10); i++)
      {       
	digitalWrite(XbPin,LOW);
		delayMicroseconds(150);
	digitalWrite(XaPin,LOW);
		delayMicroseconds(150);
	digitalWrite(XbPin,HIGH);
		delayMicroseconds(150);
	digitalWrite(XaPin,HIGH);
		delayMicroseconds(150);
        i++;
        }
}


void setup()
{
  Serial.begin(9600);
  mouse_init();
}




/*
 * EMULATION TO8
 */
void loop()
{
  char mstat;
  char mx;
  char my;
  char mz;
  int Bouton=0;
  int TimingX=600-TURBOon;    //  minimum: 70  /  maximum: ~~
  int TimingY=600-(TURBOon/3);  //-TURBOon/5;
  
	int RepetX=0;
	int RepetY=0;
	int SensX=0;
	int SensY=0;
	int BouclXY=0;
  
  /* recupére les données de la souris PS/2 */
  mouse.write(0xeb);  // envoi data!
  mouse.read();      // ignore ack
  //delay(10);
  mstat = mouse.read();  // boutons + overflow X Y
  mx = mouse.read();	//	deplacement X
  my = mouse.read();	//	deplacement Y
  if (MouseID) mz = mouse.read();		//	si type >0 alors lire 4eme octets
  Bouton=mstat & 7;		//	recupere l'etat des 3 boutons.
  
 
//	si bouton 1 est appuye alors envoi l'info au TO8
  if(Bouton&1) {digitalWrite(Bouton1Pin,LOW);} else {digitalWrite(Bouton1Pin,HIGH);}

//	si bouton 2 est appuye alors envoi l'info au TO8  
  if(Bouton&2) { digitalWrite(Bouton2Pin,LOW); } else {digitalWrite(Bouton2Pin,HIGH);}
  
//  si bouton 3 on passe en mode Turbo
 if(Bouton&4) { TURBOon=400; EnterTurboMode(); delay(100);  }
  
// Reglage du mode Turbo
if (mz==-1) { if (TURBOon<430) {TURBOon=TURBOon+10;} }
if (mz==1 ) { if (TURBOon>0  ) {TURBOon=TURBOon-10;} }  
  
// si il y a un deplacement ou un bouton appuye alors on affiche les donnees et ont
// et on envoi l'info au TO8   sinon rien.
  if ( (mx==0) & (my==0)& (mz==0) )
   {
   }
  else
  {
    Serial.print("V1.0");
	Serial.print(" Boutons:");
	Serial.print(Bouton, DEC);
	Serial.print("\tX=");
	Serial.print(mx, DEC);
	Serial.print("\tY=");
	Serial.print(my, DEC);
	Serial.print("\tZ=");
	Serial.print(mz, DEC);
          Serial.print("\tTiming=");
          Serial.print(TURBOon,DEC);
	Serial.println();
 
// affiche Turbo mode si actif 
	if (TURBOon>0)  { Serial.println("\t\t\t Turbo Mode ON "); }
  
	TimingX=TimingX-abs(mx/4);
	TimingY=TimingY-abs(my/4);

	if (mx!=0) {RepetX=1+abs(mx/10);}
	if (my!=0) {RepetY=1+abs(my/10);}
	if (mx>0)	{ SensX=1;} else {SensX=0; }
	if (my>0)	{ SensY=1;} else {SensY=0; }

	if (RepetX>RepetY) {BouclXY=RepetX;} else {BouclXY=RepetY;}
	
	
/*	
	principe de fonctionnement de la souris TO8:
	Envoie de NN cycles de = Xa,[delai],Xb,[delai],Ya,[delai],Yb,[delai]
		NN = nombre de fois que les donnees sont envoye proportionnel à la vitesse de deplacement de la souris.
		[delai] = temps d'attente entre 2 pulses.
	déplacements positifs Xa puis Xb  ou  Ya puis Yb
	déplacements negatifs Xb puis Xa  ou  Yb puis Ya
	boucle d'envoi des pulses egale au plus grand deplacement X ou Y 
*/	
	int i=0;
	while( i<=BouclXY)
	{
		if (RepetX>0)
		{
		if (SensX==1)
		{
		digitalWrite(XaPin,LOW);
				delayMicroseconds(TimingX);
		digitalWrite(XbPin,LOW);
				delayMicroseconds(TimingX);
			digitalWrite(XaPin,HIGH);
				delayMicroseconds(TimingX);
			digitalWrite(XbPin,HIGH);
				delayMicroseconds(TimingX);
        }
		else
        {
		digitalWrite(XbPin,LOW);
				delayMicroseconds(TimingX);
		digitalWrite(XaPin,LOW);
				delayMicroseconds(TimingX);
			digitalWrite(XbPin,HIGH);
				delayMicroseconds(TimingX);
			digitalWrite(XaPin,HIGH);
                                delayMicroseconds(TimingX);
        }
		RepetX--;
		}
		
		
		if (RepetY>0)
		{
		if (SensY==0)
            {
		digitalWrite(YaPin,LOW);
				delayMicroseconds(TimingY);
		digitalWrite(YbPin,LOW);
				delayMicroseconds(TimingY);
			digitalWrite(YaPin,HIGH);
				delayMicroseconds(TimingY);
			digitalWrite(YbPin,HIGH);
                                delayMicroseconds(TimingY);	
            }
		else
          {
		digitalWrite(YbPin,LOW);
				delayMicroseconds(TimingY);
		digitalWrite(YaPin,LOW);
				delayMicroseconds(TimingY);
			digitalWrite(YbPin,HIGH);
				delayMicroseconds(TimingY);
			digitalWrite(YaPin,HIGH);
                                delayMicroseconds(TimingY);	
          }
		RepetY--;
		}		
		
		
		i++;
	}
  
    Serial.println();	
  }
  
}
